



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>grep与正则表达式基础</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">grep与正则表达式基础</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 03:53:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>目录</p>
<div>
<p>grep</p>
<p>正则表达式</p>
<h2>grep用法简介</h2>
<p>我们介绍GREP的用法，主要用于匹配行，我们借助下面的正则表达式来介绍如何使用grep，还有就是正则表达式在linux中是极为重要的一部分。</p>
<div>
<pre class="prettyprint linenums"> 命令：grep<br />
 格式：grep [option] "pattern" filename<br />
 选项：<br />
          -v：反向选择<br />
          -i：忽略大小写<br />
          -n：显示行号<br />
          -c：统计行数<br />
          -o：仅显示匹配到的字符串<br />
          -w：匹配整个单词<br />
          -q：不输出任何信息<br />
          -A ：after 显示后2行<br />
          -B ：before 显示前3行<br />
          -C :context 前后各3行<br />
          -e：实现多个选项间的逻辑关系<br />
                    grep -e root -e mail /etc/passwd<br />
          -E：相当于egrep，用于使用拓展的正则表达式<br />
          -F：相当于fgrep，不支持正则表达式</pre>
</div>
<h2>正则表达式（Regular expression）</h2>
<p><strong>什么是正则表达式</strong></p>
<p>Regular expression（正则表达式）是由一类特殊字符及文本字符编写的模式，其中有些字符（元字符）不代表字符的字面意义，而表示控制或通配功能。</p>
<p><strong>那些程序支持正则表达式</strong></p>
<p>grep，sed，awk，vim，less，nginx，varnish</p>
<p><strong>在man</strong><strong>中查询</strong></p>
<p>我们可以在正则man手册中查找正则的用法</p>
<p>man 7 regex</p>
<p><strong>正则表达式的分类</strong></p>
<p>基本正则表达式</p>
<p>扩展的正则表达式</p>
<p><strong>元字符的分类</strong></p>
<p>字符匹配，匹配次数，位置锚定，分组</p>
<p><strong>基础RE(</strong><strong>用于grep)</strong></p>
<p>字符匹配</p>
<div>
<pre class="prettyprint linenums">    .        匹配任意单个字符<br />
    []       匹配指定范围内的任意单个字符<br />
    [^]      匹配指定范围外的任意字符</pre>
</div>
<p>匹配次数：用在要指定的次数的字符后面，用于指定前面的字符出现的次数</p>
<div>
<pre class="prettyprint linenums">    *           匹配前面的字符任意次（包括0次）<br />
    .*          任意长度的任意字符<br />
    \?          匹配前面的字符0次或一次<br />
    \+          匹配前面的字符至少一次<br />
    \{n\}　　　 匹配前面的字符n次<br />
    \{m,n\} 　　匹配前面的字符至少m次，最多n次<br />
    \{,n\}      匹配前面的字符最多n次<br />
    \{n,\}      匹配前面的字符最少n次</pre>
</div>
<p>位置锚定：用于定位出现的位置</p>
<div>
<pre class="prettyprint linenums"> 　　^       　　　　　行首锚定<br />
2　　 $      　　　　 　行尾锚定<br />
 　　^$    　　　　　　空行<br />
 　　^[[:space:]]$    空白行<br />
 　　\&lt;，\b           词首锚定，用于单词模式的左侧<br />
 　　\&gt;，\b           词尾锚定，用于单词模式的右侧<br />
 　　\&lt;pattern\&gt;      匹配整个单词</pre>
</div>
<p>分组：</p>
<p>\(\)将一个或多个字符捆绑在一起，当做一个整体进行处理，如\(root\)\+</p>
<p>分组括号中的模式匹配到的内容会被正则表达式引擎记录在内部的变量中，这些变量的命令方式为\1,\2,\3...</p>
<p>\1&nbsp;&nbsp;&nbsp;&nbsp; 表示从左侧起第一个左括号以及与之匹配的右括号之间的模式所匹配到的字符</p>
<p>示例：</p>
<p><strong>\(string1\+\(string2\)*\)</strong></p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \1</strong><strong>：string1\+\(string2\)*</strong></p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \2</strong><strong>：string2 </strong></p>
<p>后向引用：</p>
<p>引用前面的分组括号中的模式所匹配的字符，而非模式本身</p>
<p>或者：\|</p>
<p><strong>扩展RE</strong><strong>（用于egrep</strong><strong>或grep </strong><strong>&mdash;E</strong><strong>）</strong></p>
<p>字符匹配：</p>
<div>
<pre class="prettyprint linenums">  　　.        匹配任意单个字符<br />
 　　 []       匹配指定范围内的任意单个字符<br />
 　　 [^]     匹配指定范围外的任意字符</pre>
</div>
<p>匹配次数</p>
<div>
<pre class="prettyprint linenums">  　　*                匹配前面的字符任意次（包括0次）<br />
  　　?                匹配前面的字符0次或一次<br />
 　　 +                匹配前面的字符至少一次<br />
  　　{n}    　　　　　 匹配前面的字符n次<br />
 　　 {m,n} 　　　　　　匹配前面的字符至少m次，最多n次</pre>
</div>
<p>位置锚定</p>
<div>
<pre class="prettyprint linenums"> 　　^ :　　　　 行首<br />
  　 $ :　　　　 行尾<br />
  　 \&lt;, \b :　　语首<br />
  　 \&gt;, \b :　　语尾       &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</pre>
</div>
<p>分组：</p>
<div>
<pre class="prettyprint linenums">     ()<br />
     后向引用： \, \, ...  &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;</pre>
</div>
<p>或者：</p>
<div>
<pre class="prettyprint linenums">     a|b: a或b<br />
     C|cat: C或cat<br />
     (C|c)at:Cat或cat &nbsp;&nbsp;</pre>
</div>
<p>特殊字符</p>
<div>
<pre class="prettyprint linenums">      [:alnum:] 字母和数字<br />
      [:alpha:] 代表任何英文大小写字符，亦即 A-Z, a-z<br />
      [:lower:] 小写字母<br />
      [:upper:] 大写字母<br />
      [:blank:] 水平空白字符（空格和制表符）<br />
      [:space:] 所有水平和垂直的空白字符（比[:blank:]包含的范围广）<br />
      [:cntrl:] 不可打印的控制字符（退格、删除、警铃...）<br />
      [:digit:] 十进制数字<br />
      [:graph:] 可打印的非空白字符<br />
      [:print:] 可打印字符<br />
      [:punct:] 标点符号<br />
      [:xdigit:] 十六进制数字  &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;</pre>
</div>
<h3>grep</h3>
<p><strong>1、</strong><strong>显示/proc/meminfo</strong><strong>文件中以大小s</strong><strong>开头的行(</strong><strong>要求：使用两种方法)</strong></p>
<div>
<pre class="prettyprint linenums">cat /proc/meminfo | grep "^[sS]"<br />
cat /proc/meminfo | grep "^[s\|S]"<br />
cat /proc/meminfo | grep "^s\|^S"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170729212505910-315564714.png" /></p>
<p><strong>2、</strong><strong>显示/etc/passwd</strong><strong>文件中不以/bin/bash</strong><strong>结尾的行</strong></p>
<div>
<pre class="prettyprint linenums">cat /etc/passwd | grep -v "/bin/bash$"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730135435474-898002742.png" /></p>
<p><strong>3、</strong><strong>显示用户rpc</strong><strong>默认的shell</strong><strong>程序</strong></p>
<div>
<pre class="prettyprint linenums">cat /etc/passwd | grep "^rpc\&gt;" | grep -o "[^/]\+$"<br />
cat /etc/passwd | grep "^rpc\&gt;" | cut -d"/" -f6</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730135813427-51080288.png" /></p>
<p><strong>4、</strong><strong>找出/etc/passwd</strong><strong>中的两位或三位数</strong></p>
<div>
<pre class="prettyprint linenums">cat /etc/passwd | grep "\b[0-9]\{2,3\}\b"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730140033271-1280689051.png" /></p>
<p><strong>5</strong><strong>、显示CentOS7</strong><strong>的/etc/grub2.cfg</strong><strong>文件中，至少以一个空白字符开头的且后面存非空白&nbsp;</strong><strong>字符的行</strong></p>
<div>
<pre class="prettyprint linenums">cat grub2.txt | grep "^[[:space:]]\+[[:graph:]].*"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730140453162-1812954265.png" /></p>
<p><strong>6</strong><strong>、找出&ldquo;netstat -tan</strong><strong>&rdquo;命令的结果中以&lsquo;LISTEN</strong><strong>&rsquo;后跟任意多个空白字符结尾的行</strong></p>
<div>
<pre class="prettyprint linenums">netstat -tan | grep "LISTEN[[:space:]]*$"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730140645709-815204179.png" /></p>
<p><strong>7</strong><strong>、显示CentOS7</strong><strong>上所有系统用户的用户名和UID</strong></p>
<div>
<pre class="prettyprint linenums">cat /etc/passwd | cut -d ":" -f 1,3 | grep -v "\b0$" | grep "\b[0-9]\{1,3\}\b"<br />
cat /etc/passwd | cut -d ":" -f 1,3 | grep -ve "\b0$" -e "[0-9]\{4,\}"　</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730141102834-1318382636.png" /></p>
<p><strong>8</strong><strong>、添加用户bash</strong><strong>、 testbash</strong><strong>、 basher</strong><strong>、 sh</strong><strong>、 nologin(</strong><strong>其shell</strong><strong>为/sbin/nologin),</strong><strong>找出&nbsp;/etc/passwd</strong><strong>用户名同shell</strong><strong>名的行</strong></p>
<div>
<pre class="prettyprint linenums">cat /etc/passwd | grep "\(^[[:alnum:]]\+\&gt;\).*\&lt;\1$"　</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730141356974-456446381.png" /></p>
<p><strong>9</strong><strong>、利用df</strong><strong>和grep</strong><strong>及sort</strong><strong>，取出磁盘各分区利用率，并从大到小排序</strong></p>
<div>
<pre class="prettyprint linenums">df | grep "/dev/sd" | grep -o "[0-9]\{1,\}%" | sort -nr&nbsp;</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730141648099-1825862492.png" /></p>
<h3>egrep</h3>
<p><strong>1、</strong><strong>显示三个用户root</strong><strong>、 mage</strong><strong>、 wang</strong><strong>的UID</strong><strong>和默认shell</strong></p>
<div>
<pre class="prettyprint linenums">cat /etc/passwd | egrep "^root|^mage|^wang" | tr -s ":" "/" | cut -d"/" -f3,8<br />
cat /etc/passwd | egrep "^root|^mage|^wang" | cut -d":" -f3,7</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730142719052-1628801756.png" /></p>
<p><strong>2、</strong><strong>找出/etc/rc.d/init.d/functions</strong><strong>文件中行首为某单词(</strong><strong>包括下划线)</strong><strong>后面跟一个小括号</strong><strong>的行</strong></p>
<div>
<pre class="prettyprint linenums">cat /etc/rc.d/init.d/functions | egrep -o "^([[:alpha:]]+|_).*[[:graph:]]\(\)"<br />
cat /etc/rc.d/init.d/functions | egrep -o "^.*[[:grpha:]]\(\)"<br />
cat /etc/rc.d/init.d/functions |egrep -o "^.*\&gt;\(\)"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170731191826036-93629497.png" /></p>
<p><strong>3、</strong><strong>使用egrep</strong><strong>取出/etc/rc.d/init.d/functions</strong><strong>中其基名</strong></p>
<div>
<pre class="prettyprint linenums">echo /etc/rc.d/init.d/functions | egrep -o "\b[[:alnum:]]+/*$"<br />
echo /etc/rc.d/init.d/functions | egrep -o "\b[[:alnum:]]+/?$"<br />
echo /etc/rc.d/init.d/functions |egrep "[^/]+/?$" -o</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730194356865-1397567441.png" /></p>
<p><strong>4、</strong><strong>使用egrep</strong><strong>取出上面路径的目录名</strong></p>
<div>
<pre class="prettyprint linenums">echo /etc/rc.d/init.d/functions | egrep -o  ".*/\&lt;"<br />
echo /etc/rc.d/init.d/functions |egrep -o ".*/." |egrep -o</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170731192208740-232931146.png" /></p>
<p><strong>5</strong><strong>、统计last</strong><strong>命令中以root</strong><strong>登录的每个主机IP</strong><strong>地址登录次数</strong></p>
<div>
<pre class="prettyprint linenums">last | grep ^root | egrep -o "([0-9]{1,3}\.){3}[0-9]{1,3}" | sort | uniq -c　</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730195327787-541018245.png" /></p>
<p><strong>6、</strong><strong>利用扩展正则表达式分别表示0-9</strong><strong>、 10-99</strong><strong>、 100-199</strong><strong>、200-249</strong><strong>、 250-255</strong></p>
<div>
<pre class="prettyprint linenums">echo {1..1000} | egrep -o "\b[0-9]\b" | tr "\n" " " ;echo<br />
echo {1..1000} | egrep -o "\b[0-9]{2}\b" | tr "\n" " " ;echo<br />
echo {1..1000} | egrep -o "\b1[0-9]{2}\b" | tr "\n" " " ;echo<br />
echo {1..1000} | egrep -o "\b2[0-4][0-9]\b" | tr "\n" " " ;echo<br />
echo {1..1000} | egrep -o "\b25[0-5]\b" | tr "\n" " " ;echo　</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730195852005-1763973868.png" /></p>
<p><strong>7、</strong><strong>显示ifconfig</strong><strong>命令结果中所有IPv4</strong><strong>地址</strong></p>
<div>
<pre class="prettyprint linenums">ifconfig|egrep -o "\&lt;(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4]0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\&gt;"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170731192509755-547195163.png" /></p>
<p><strong>8</strong><strong>、将此字符串： welcome to magedu linux </strong><strong>中的每个字符去重并排序，重复次数多的</strong><strong>排到前面</strong></p>
<div>
<pre class="prettyprint linenums">echo "welcome to magedu linux" | tr -d " " | grep -o "." | sort | uniq -c | sort -nr&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;</pre>
</div>
<p><em><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1174645/201707/1174645-20170730200412537-550708080.png" />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;</em></p>
</div>
<p><!--<br />
/* Font Definitions */<br />
 @font-face<br />
	{font-family:宋体;<br />
	panose-1:2 1 6 0 3 1 1 1 1 1;<br />
	mso-font-alt:SimSun;<br />
	mso-font-charset:134;<br />
	mso-generic-font-family:auto;<br />
	mso-font-pitch:variable;<br />
	mso-font-signature:3 680460288 22 0 262145 0;}<br />
@font-face<br />
	{font-family:宋体;<br />
	panose-1:2 1 6 0 3 1 1 1 1 1;<br />
	mso-font-alt:SimSun;<br />
	mso-font-charset:134;<br />
	mso-generic-font-family:auto;<br />
	mso-font-pitch:variable;<br />
	mso-font-signature:3 680460288 22 0 262145 0;}<br />
@font-face<br />
	{font-family:Calibri;<br />
	panose-1:2 15 5 2 2 2 4 3 2 4;<br />
	mso-font-charset:0;<br />
	mso-generic-font-family:swiss;<br />
	mso-font-pitch:variable;<br />
	mso-font-signature:-536870145 1073786111 1 0 415 0;}<br />
@font-face<br />
	{font-family:"Calibri Light";<br />
	panose-1:2 15 3 2 2 2 4 3 2 4;<br />
	mso-font-charset:0;<br />
	mso-generic-font-family:swiss;<br />
	mso-font-pitch:variable;<br />
	mso-font-signature:-1610611985 1073750139 0 0 415 0;}<br />
@font-face<br />
	{font-family:"\@宋体";<br />
	panose-1:2 1 6 0 3 1 1 1 1 1;<br />
	mso-font-charset:134;<br />
	mso-generic-font-family:auto;<br />
	mso-font-pitch:variable;<br />
	mso-font-signature:3 680460288 22 0 262145 0;}<br />
 /* Style Definitions */<br />
 p.MsoNormal, li.MsoNormal, div.MsoNormal<br />
	{mso-style-unhide:no;<br />
	mso-style-qformat:yes;<br />
	mso-style-parent:"";<br />
	margin:0cm;<br />
	margin-bottom:.0001pt;<br />
	text-align:justify;<br />
	text-justify:inter-ideograph;<br />
	mso-pagination:none;<br />
	font-size:10.5pt;<br />
	mso-bidi-font-size:12.0pt;<br />
	font-family:"Calibri","sans-serif";<br />
	mso-ascii-font-family:Calibri;<br />
	mso-ascii-theme-font:minor-latin;<br />
	mso-fareast-font-family:宋体;<br />
	mso-fareast-theme-font:minor-fareast;<br />
	mso-hansi-font-family:Calibri;<br />
	mso-hansi-theme-font:minor-latin;<br />
	mso-bidi-font-family:"Times New Roman";<br />
	mso-bidi-theme-font:minor-bidi;<br />
	mso-font-kerning:1.0pt;}<br />
h2<br />
	{mso-style-qformat:yes;<br />
	mso-style-link:"标题 2 Char";<br />
	mso-style-next:正文;<br />
	margin-top:13.0pt;<br />
	margin-right:0cm;<br />
	margin-bottom:13.0pt;<br />
	margin-left:0cm;<br />
	text-align:justify;<br />
	text-justify:inter-ideograph;<br />
	line-height:173%;<br />
	mso-pagination:lines-together;<br />
	page-break-after:avoid;<br />
	mso-outline-level:2;<br />
	font-size:16.0pt;<br />
	font-family:"Calibri Light","sans-serif";<br />
	mso-ascii-font-family:"Calibri Light";<br />
	mso-ascii-theme-font:major-latin;<br />
	mso-fareast-font-family:宋体;<br />
	mso-fareast-theme-font:major-fareast;<br />
	mso-hansi-font-family:"Calibri Light";<br />
	mso-hansi-theme-font:major-latin;<br />
	mso-bidi-font-family:"Times New Roman";<br />
	mso-bidi-theme-font:major-bidi;<br />
	mso-font-kerning:1.0pt;}<br />
h3<br />
	{mso-style-qformat:yes;<br />
	mso-style-link:"标题 3 Char";<br />
	mso-style-next:正文;<br />
	margin-top:13.0pt;<br />
	margin-right:0cm;<br />
	margin-bottom:13.0pt;<br />
	margin-left:0cm;<br />
	text-align:justify;<br />
	text-justify:inter-ideograph;<br />
	line-height:173%;<br />
	mso-pagination:lines-together;<br />
	page-break-after:avoid;<br />
	mso-outline-level:3;<br />
	font-size:16.0pt;<br />
	font-family:"Calibri","sans-serif";<br />
	mso-ascii-font-family:Calibri;<br />
	mso-ascii-theme-font:minor-latin;<br />
	mso-hansi-font-family:Calibri;<br />
	mso-hansi-theme-font:minor-latin;<br />
	mso-font-kerning:1.0pt;}<br />
span.2Char<br />
	{mso-style-name:"标题 2 Char";<br />
	mso-style-unhide:no;<br />
	mso-style-locked:yes;<br />
	mso-style-link:"标题 2";<br />
	mso-ansi-font-size:16.0pt;<br />
	mso-bidi-font-size:16.0pt;<br />
	font-family:"Calibri Light","sans-serif";<br />
	mso-ascii-font-family:"Calibri Light";<br />
	mso-ascii-theme-font:major-latin;<br />
	mso-fareast-font-family:宋体;<br />
	mso-fareast-theme-font:major-fareast;<br />
	mso-hansi-font-family:"Calibri Light";<br />
	mso-hansi-theme-font:major-latin;<br />
	mso-bidi-font-family:"Times New Roman";<br />
	mso-bidi-theme-font:major-bidi;<br />
	mso-font-kerning:1.0pt;<br />
	font-weight:bold;}<br />
span.3Char<br />
	{mso-style-name:"标题 3 Char";<br />
	mso-style-unhide:no;<br />
	mso-style-locked:yes;<br />
	mso-style-link:"标题 3";<br />
	mso-ansi-font-size:16.0pt;<br />
	mso-bidi-font-size:16.0pt;<br />
	mso-font-kerning:1.0pt;<br />
	font-weight:bold;}<br />
.MsoChpDefault<br />
	{mso-style-type:export-only;<br />
	mso-default-props:yes;<br />
	font-size:10.0pt;<br />
	mso-ansi-font-size:10.0pt;<br />
	mso-bidi-font-size:10.0pt;<br />
	font-family:"Calibri","sans-serif";<br />
	mso-bidi-font-family:"Times New Roman";<br />
	mso-bidi-theme-font:minor-bidi;<br />
	mso-font-kerning:0pt;}<br />
 /* Page Definitions */<br />
 @page<br />
	{mso-page-border-surround-header:no;<br />
	mso-page-border-surround-footer:no;}<br />
@page WordSection1<br />
	{size:595.3pt 841.9pt;<br />
	margin:72.0pt 90.0pt 72.0pt 90.0pt;<br />
	mso-header-margin:42.55pt;<br />
	mso-footer-margin:49.6pt;<br />
	mso-paper-source:0;<br />
	layout-grid:15.6pt;}<br />
div.WordSection1<br />
	{page:WordSection1;}<br />
 /* List Definitions */<br />
 @list l0<br />
	{mso-list-id:1501293692;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501293692;}<br />
@list l0:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l1<br />
	{mso-list-id:1501293723;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501293723;}<br />
@list l1:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l2<br />
	{mso-list-id:1501293792;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501293792;}<br />
@list l2:level1<br />
	{mso-level-start-at:2;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l3<br />
	{mso-list-id:1501293935;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501293935;}<br />
@list l3:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l4<br />
	{mso-list-id:1501295467;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501295467;}<br />
@list l4:level1<br />
	{mso-level-start-at:3;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l5<br />
	{mso-list-id:1501297324;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501297324;}<br />
@list l5:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l6<br />
	{mso-list-id:1501297412;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501297412;}<br />
@list l6:level1<br />
	{mso-level-start-at:4;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l7<br />
	{mso-list-id:1501312874;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501312874;}<br />
@list l7:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l8<br />
	{mso-list-id:1501312904;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501312904;}<br />
@list l8:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l9<br />
	{mso-list-id:1501313050;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501313050;}<br />
@list l9:level1<br />
	{mso-level-start-at:2;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l10<br />
	{mso-list-id:1501314213;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501314213;}<br />
@list l10:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l11<br />
	{mso-list-id:1501314250;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501314250;}<br />
@list l11:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l12<br />
	{mso-list-id:1501314265;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501314265;}<br />
@list l12:level1<br />
	{mso-level-start-at:3;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l13<br />
	{mso-list-id:1501315119;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501315119;}<br />
@list l13:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l14<br />
	{mso-list-id:1501315136;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501315136;}<br />
@list l14:level1<br />
	{mso-level-start-at:4;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l15<br />
	{mso-list-id:1501315344;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501315344;}<br />
@list l15:level1<br />
	{mso-level-start-at:6;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l16<br />
	{mso-list-id:1501315357;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501315357;}<br />
@list l16:level1<br />
	{mso-level-start-at:7;<br />
	mso-level-suffix:none;<br />
	mso-level-text:%1、;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l17<br />
	{mso-list-id:1501315796;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501315796;}<br />
@list l17:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l18<br />
	{mso-list-id:1501315868;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501315868;}<br />
@list l18:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
@list l19<br />
	{mso-list-id:1501316358;<br />
	mso-list-type:simple;<br />
	mso-list-template-ids:1501316358;}<br />
@list l19:level1<br />
	{mso-level-suffix:none;<br />
	mso-level-tab-stop:none;<br />
	mso-level-number-position:left;<br />
	margin-left:0cm;<br />
	text-indent:0cm;}<br />
ol<br />
	{margin-bottom:0cm;}<br />
ul<br />
	{margin-bottom:0cm;}<br />
--></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gk7z87.html">在PC上测试移动端网站和模拟手机浏览器的5大方</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96oy139.html">Docker初体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/m963e1v9.html">PlayMaker的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jxl54q.html">hadoop2&period;6&period;2分布式环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2wj18.html">BZOJ1588&mdash;&mdash;&lbrack;HNOI2002&rsqb;营业额统计</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2lkvw9.html">Linux 下 git连接github的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p430z9.html">linux 错误处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql6z3xq.html">安装docker1&period;10</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15j3k9.html">Visual Basic相关图书推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02rg0q.html">java如何得到GET和POST请求URL和参数列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmg0zz9.html">Jeecms自定义标签用法&lbrack;单个内容&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y7e30q.html">office安装不了 &OpenCurlyDoubleQuote;windows installer 服务不能更新一个或多个受保护的windows文件&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw25x9.html">Keras Xception Multi loss 细粒度图像分类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jy1vx8.html">asp&period;net web api 文件上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1wx7zq.html">&lbrack;C&plus;&plus;学习历程&rsqb;Visual Studio 2010 的HelloWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz5g448.html">time-based基于google key生成6位验证码（google authenticator）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g33e0q.html">Android为TV端助力 同时setTag两次，保存多种值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdonxd9.html">Summary of Java basics review data</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyeopv9.html">sql查询语句for xml path语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j624eq.html">&lpar;其他&rpar;最常用的15大Eclipse开发快捷键技巧</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdpkn47q.html">MyBatis实现Mysql数据库分库分表操作和总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp2wv79.html">关于Thread类的简单使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/950d56e8.html">ABP module-zero &plus;AdminLTE&plus;Bootstrap Table&plus;jQuery权限管理系统第十二节--小结&comma;Bootstrap Table之角色管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzvjnl8.html">【win10】大水牛主机插入耳机没有声音</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpg0m0q.html">用DOS命令来运行Java代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljwmm19.html">VMware Workstation 12 Player之安装林耐斯-Linux Deepin -系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk6nyd8.html">Java web开发，在一个jsp里放太多java代码的后果，摘自 java web轻量级开发面试教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jgx6v8.html">Linux平台 Oracle 12cR2 RAC安装Part1：准备工作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpg53xq.html">关于vue的一些总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gez4m48.html">&lbrack;C&rsqb;成员运算符&amp;quot&semi;&period;&amp;quot&semi;和间接成员运算符&amp;quot&semi;-&amp;gt&semi;&amp;quot&semi;浅析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
